#ifndef GLOBALS_H
#define GLOBALS_H

extern "C" {
#include <gd.h>
#include <gdfontt.h>
#include <gdfontmb.h>
}
#include "time.h"

// Fonts
extern char *fontTimes;             /* TrueType font */
extern char *fontComic;             /* TrueType font */
extern char *fontComicBold;             /* TrueType font */

// Plot Parameters
#define x1 2
extern int xPICFROM;
extern int xRIGHTSHIFT;
#define ANNO_HEIGHT 10

template <class X> X min(X a, X b) { return (a<b) ? a : b; }
template <class X> X max(X a, X b) { return (a>b) ? a : b; }

////////////////////////////////////////////////////////////
/* *** STRUCTURES *** */

typedef struct {
    char *name;
    int strand;
    unsigned long int from, to;
} GeneStruct;

typedef struct {
    short unsigned int left, right;
} AlignLine;

#define ArraySize(a) sizeof(a)/sizeof((a)[0])

////////////////////////////////////////////////////////////
/* *** INPUT PARAMETERS *** */

// Default parameters
extern int ecrWin, ecrId;
extern int SMOOTH;
extern int numSeq, nLayerBases, xMax, yLayer, percFrom, percTo, topBottom, from, to;
extern char **GenBinAlnFileName, **GenSeqFileName;

extern int white, black, blue, yellow, red, green, yellishBkgnd, gray;
extern int color[10];

extern int removeLegend;
extern int justPrintEcrs;
extern int calculateId;

/* *** CONSERVATION, ANNOTATION *** */
extern int **Conservation;
extern int **PipConservation;
extern AlignLine **Alignment;
extern long int *Annotation, nAnnoLines;
extern long int *nECR, **ECR;
extern int nGenes;
extern GeneStruct *Gene;
extern long int consLen;

////////////// BLASTZ ALIGNMENT STRUCTURE ////////////////////

extern char **header1, **header2;

extern int *length1, *length2;
extern int *nAlignments;

typedef struct {
    int score;
    int nBlocks;
    int strand;
    int from1,from2,to1,to2;
    int *data;
} alignBlock;

extern alignBlock **ALT;

extern char **seq;

////////////////////////////////////////////////////////////

#endif /* GLOBALS_H */
