#ifndef ZPICTURE_H
#define ZPICTURE_H

#include "globals.h"
#include "ecr.h"
#include "readAlignment.h"
#include "draw.h"

// Conservation parameter
#define WINDOW 100

// VISUALIZATION
int xPICFROM=55;
int xRIGHTSHIFT=80;

// Fonts
char *fontTimes = "/usr/X11R6/lib/X11/fonts/webfonts/timesb.ttf";             /* TrueType font */
char *fontComic = "/usr/X11R6/lib/X11/fonts/webfonts/comic.ttf";             /* TrueType font */
char *fontComicBold = "/usr/X11R6/lib/X11/fonts/webfonts/comicbd.ttf";             /* TrueType font */

/* *** FUNCTIONS *** */

void getOptions(int &argc, char *argv[]);
int checkOption(int &i, int &argc, char *argv[], char *parameter, int &value, int type);

void GetAnnotation(char *ExonsFileName, char *RepeatsFileName);


/* *** INPUT PARAMETERS *** */

// Default parameters
int ecrWin, ecrId;
int SMOOTH;
int numSeq, nLayerBases, xMax, yLayer, percFrom, percTo, topBottom, from, to;
char **GenBinAlnFileName, **GenSeqFileName;

int white, black, blue, yellow, red, green, yellishBkgnd, gray;
int color[10];

int removeLegend;
int justPrintEcrs;
int calculateId;

/* *** CONSERVATION, ANNOTATION *** */
int **Conservation;
int **PipConservation;
AlignLine **Alignment;
long int *Annotation, nAnnoLines;
long int *nECR, **ECR;
int nGenes;
GeneStruct *Gene;
long int consLen;

////////////// BLASTZ ALIGNMENT STRUCTURE ////////////////////

char **header1, **header2;

int *length1, *length2;
int *nAlignments;

alignBlock **ALT;

char **seq;

/////////////////////////////////////////////////////////////////

#endif /* ZPICTURE_H */
